// Settings.cpp : implementation file
//

#include "stdafx.h"
#include "oh_joy.h"
#include "Settings.h"

#include "stdio.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSettings dialog


CSettings::CSettings(CWnd* pParent /*=NULL*/)
	: CDialog(CSettings::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSettings)
	m_A = 0.0;
	m_B = 0.0;
	m_C = 0.0;
	m_Top = 0.0;
	m_Left = 0.0;
	m_Bottom = 0.0;
	m_Right = 0.0;
	m_plot_mode = _T("");
	m_Render_width = 0;
	m_Render_height = 0;
	m_Iteration = 0;
	m_D = 0.0;
	m_E = 0.0;
	m_F = 0.0;
	m_Init_x = 0.0;
	m_Init_y = 0.0;
	//}}AFX_DATA_INIT
}


void CSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettings)
	DDX_Text(pDX, IDC_EDIT_01, m_A);
	DDV_MinMaxDouble(pDX, m_A, -1000., 1000.);
	DDX_Text(pDX, IDC_EDIT_02, m_B);
	DDV_MinMaxDouble(pDX, m_B, -1000., 1000.);
	DDX_Text(pDX, IDC_EDIT_03, m_C);
	DDV_MinMaxDouble(pDX, m_C, -1000., 1000.);
	DDX_Text(pDX, IDC_EDIT_04, m_D);
	DDV_MinMaxDouble(pDX, m_D, -1000., 1000.);
	DDX_Text(pDX, IDC_EDIT_05, m_E);
	DDV_MinMaxDouble(pDX, m_E, -1000., 1000.);
	DDX_Text(pDX, IDC_EDIT_06, m_F);
	DDV_MinMaxDouble(pDX, m_F, -1000., 1000.);
	DDX_Text(pDX, IDC_EDIT_07, m_Init_x);
	DDV_MinMaxDouble(pDX, m_Init_x, -1000., 1000.);
	DDX_Text(pDX, IDC_EDIT_08, m_Init_y);
	DDV_MinMaxDouble(pDX, m_Init_y, -1000., 1000.);
	DDX_Text(pDX, IDC_EDIT_09, m_Iteration);
	DDV_MinMaxInt(pDX, m_Iteration, 100, 10000000);
	DDX_Text(pDX, IDC_EDIT_10, m_Top);
	DDV_MinMaxDouble(pDX, m_Top, -1000., 1000.);
	DDX_Text(pDX, IDC_EDIT_11, m_Left);
	DDV_MinMaxDouble(pDX, m_Left, -1000., 1000.);
	DDX_Text(pDX, IDC_EDIT_12, m_Bottom);
	DDV_MinMaxDouble(pDX, m_Bottom, -1000., 1000.);
	DDX_Text(pDX, IDC_EDIT_13, m_Right);
	DDV_MinMaxDouble(pDX, m_Right, -1000., 1000.);
	DDX_CBString(pDX, IDC_COMBO1, m_plot_mode);
	DDV_MaxChars(pDX, m_plot_mode, 20);
	DDX_Text(pDX, IDC_EDIT_14, m_Render_width);
	DDV_MinMaxInt(pDX, m_Render_width, 100, 2000);
	DDX_Text(pDX, IDC_EDIT_15, m_Render_height);
	DDV_MinMaxInt(pDX, m_Render_height, 100, 2000);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSettings, CDialog)
	//{{AFX_MSG_MAP(CSettings)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON_1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON_2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON_3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON_4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON_5, OnButton5)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettings message handlers

BOOL CSettings::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_brush.CreateSolidBrush(RGB(192,192,255));
	GetDlgItem(IDC_BUTTON_BOX_1)->GetWindowRect(&m_button_rect_1);
	ScreenToClient(&m_button_rect_1);
	GetDlgItem(IDC_BUTTON_BOX_2)->GetWindowRect(&m_button_rect_2);
	ScreenToClient(&m_button_rect_2);
	GetDlgItem(IDC_BUTTON_BOX_3)->GetWindowRect(&m_button_rect_3);
	ScreenToClient(&m_button_rect_3);
	GetDlgItem(IDC_BUTTON_BOX_4)->GetWindowRect(&m_button_rect_4);
	ScreenToClient(&m_button_rect_4);
	m_button_rect_1.bottom-=4;
	m_button_rect_1.top+=9;
	m_button_rect_1.left+=5;
	m_button_rect_1.right-=4;
	m_button_rect_2.bottom-=4;
	m_button_rect_2.top+=9;
	m_button_rect_2.left+=5;
	m_button_rect_2.right-=4;
	m_button_rect_3.bottom-=4;
	m_button_rect_3.top+=9;
	m_button_rect_3.left+=5;
	m_button_rect_3.right-=4;
	m_button_rect_4.bottom-=4;
	m_button_rect_4.top+=9;
	m_button_rect_4.left+=5;
	m_button_rect_4.right-=4;
	if (m_Formula=="Hopalong Formula 1")
	{
		m_Formula_number = 1;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(false);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"Hopalong Formula 1");
	}
	if (m_Formula=="Hopalong Formula 2")
	{
		m_Formula_number = 2;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(false);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"Hopalong Formula 2");
	}
	if (m_Formula=="Fred Schimmel's Formula")
	{
		m_Formula_number = 3;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(true);
		SetDlgItemText(IDC_STATIC_BUTTON,"Fred Schimmel's Formula");
	}
	if (m_Formula=="Three Ply")
	{
		m_Formula_number = 4;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"Three Ply");
	}
	if (m_Formula=="Quadrup 2")
	{
		m_Formula_number = 5;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(false);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"Quadrup 2");
	}
	if (m_Formula=="Schimmel Variant One")
	{
		m_Formula_number=6;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(true);
		SetDlgItemText(IDC_STATIC_BUTTON,"Schimmel Variant One");
	}
	if (m_Formula=="GroundNet One")
	{
		m_Formula_number = 7;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet One");
	}
	if (m_Formula=="GroundNet Two")
	{
		m_Formula_number = 8;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Two");
	}
	if (m_Formula=="GroundNet Three")
	{
		m_Formula_number = 9;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Three");
	}
	if (m_Formula=="GroundNet Four")
	{
		m_Formula_number = 10;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Four");
	}
	if (m_Formula=="GroundNet Five")
	{
		m_Formula_number = 11;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Five");
	}
	if (m_Formula=="GroundNet Six")
	{
		m_Formula_number = 12;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Six");
	}
	if (m_Formula=="GroundNet Seven")
	{
		m_Formula_number = 13;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Seven");
	}
	if (m_Formula=="GroundNet Eight")
	{
		m_Formula_number = 14;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Eight");
	}
	if (m_Formula=="GroundNet Nine")
	{
		m_Formula_number = 15;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Nine");
	}
	if (m_Formula=="GroundNet Ten")
	{
		m_Formula_number = 16;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Ten");
	}
	if (m_Formula=="GroundNet Eleven")
	{
		m_Formula_number = 17;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Eleven");
	}
	if (m_Formula=="GroundNet Twelve")
	{
		m_Formula_number = 18;
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Twelve");
	}
	return true;
}

void CSettings::OnPaint() 
{
	CBrush brush_1(m_color_1);
	CBrush brush_2(m_color_2);
	CBrush brush_3(m_color_3);
	CBrush brush_4(m_color_4);

	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here
	dc.FillRect(&m_button_rect_1, &brush_1);
	dc.FillRect(&m_button_rect_2, &brush_2);
	dc.FillRect(&m_button_rect_3, &brush_3);
	dc.FillRect(&m_button_rect_4, &brush_4);
	// Do not call CDialog::OnPaint() for painting messages
}

void CSettings::OnButton1() 
{
	// TODO: Add your control notification handler code here
	CColorDialog ClrDlg;

	ClrDlg.m_cc.Flags=ClrDlg.m_cc.Flags|CC_FULLOPEN|CC_RGBINIT;
	ClrDlg.m_cc.rgbResult=m_color_1;
	if (ClrDlg.DoModal()==IDOK)
	{
		m_color_1=ClrDlg.GetColor();
	}
	InvalidateRect(&m_button_rect_1);
	UpdateWindow();
}

void CSettings::OnButton2() 
{
	// TODO: Add your control notification handler code here
	CColorDialog ClrDlg;

	ClrDlg.m_cc.Flags=ClrDlg.m_cc.Flags|CC_FULLOPEN|CC_RGBINIT;
	ClrDlg.m_cc.rgbResult=m_color_2;
	if (ClrDlg.DoModal()==IDOK)
	{
		m_color_2=ClrDlg.GetColor();
	}
	InvalidateRect(&m_button_rect_2);
	UpdateWindow();	
}

void CSettings::OnButton3() 
{
	// TODO: Add your control notification handler code here
	CColorDialog ClrDlg;

	ClrDlg.m_cc.Flags=ClrDlg.m_cc.Flags|CC_FULLOPEN|CC_RGBINIT;
	ClrDlg.m_cc.rgbResult=m_color_3;
	if (ClrDlg.DoModal()==IDOK)
	{
		m_color_3=ClrDlg.GetColor();
	}
	InvalidateRect(&m_button_rect_3);
	UpdateWindow();	
}

void CSettings::OnButton4() 
{
	// TODO: Add your control notification handler code here
	CColorDialog ClrDlg;

	ClrDlg.m_cc.Flags=ClrDlg.m_cc.Flags|CC_FULLOPEN|CC_RGBINIT;
	ClrDlg.m_cc.rgbResult=m_color_4;
	if (ClrDlg.DoModal()==IDOK)
	{
		m_color_4=ClrDlg.GetColor();
	}
	InvalidateRect(&m_button_rect_4);
	UpdateWindow();	
}


void CSettings::OnButton5() 
{
	// TODO: Add your control notification handler code here
	m_Formula_number +=1;
	if (m_Formula_number==19) m_Formula_number=1;
	
	if (m_Formula_number==1)
	{
		m_Formula="Hopalong Formula 1";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(false);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"Hopalong Formula 1");
	}
	if (m_Formula_number==2)
	{
		m_Formula="Hopalong Formula 2";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(false);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"Hopalong Formula 2");
	}
	if (m_Formula_number==3)
	{
		m_Formula="Fred Schimmel's Formula";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(true);
		SetDlgItemText(IDC_STATIC_BUTTON,"Fred Schimmel's Formula");
	}
	if (m_Formula_number==4)
	{
		m_Formula="Three Ply";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"Three Ply");
	}
	if (m_Formula_number==5)
	{
		m_Formula="Quadrup 2";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(false);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"Quadrup 2");
	}
	if (m_Formula_number==6)
	{
		m_Formula="Schimmel Variant One";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(true);
		SetDlgItemText(IDC_STATIC_BUTTON,"Schimmel Variant One");
	}
	if (m_Formula_number==7)
	{
		m_Formula="GroundNet One";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet One");
	}
	if (m_Formula_number==8)
	{
		m_Formula="GroundNet Two";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Two");
	}
	if (m_Formula_number==9)
	{
		m_Formula="GroundNet Three";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Three");
	}
	if (m_Formula_number==10)
	{
		m_Formula="GroundNet Four";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Four");
	}
	if (m_Formula_number==11)
	{
		m_Formula="GroundNet Five";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Five");
	}
	if (m_Formula_number==12)
	{
		m_Formula="GroundNet Six";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Six");
	}
	if (m_Formula_number==13)
	{
		m_Formula="GroundNet Seven";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Seven");
	}
	if (m_Formula_number==14)
	{
		m_Formula="GroundNet Eight";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Eight");
	}
	if (m_Formula_number==15)
	{
		m_Formula="GroundNet Nine";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Nine");
	}
	if (m_Formula_number==16)
	{
		m_Formula="GroundNet Ten";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Ten");
	}
	if (m_Formula_number==17)
	{
		m_Formula="GroundNet Eleven";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Eleven");
	}
	if (m_Formula_number==18)
	{
		m_Formula="GroundNet Twelve";
		GetDlgItem(IDC_EDIT_01)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_02)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_03)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_04)->EnableWindow(true);
		GetDlgItem(IDC_EDIT_05)->EnableWindow(false);
		SetDlgItemText(IDC_STATIC_BUTTON,"GroundNet Twelve");
	}
}

HBRUSH CSettings::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if (pWnd->GetDlgCtrlID() == IDC_STATIC_BUTTON)
	{
		pDC->SetTextColor(RGB(0, 0, 0));
		pDC->SetBkMode(TRANSPARENT);
		hbr = m_brush;
	}
	return hbr;
}
