// oh_joyView.cpp : implementation of the COh_joyView class
//

#include "stdafx.h"
#include "oh_joy.h"

#include "math.h"

#include "oh_joyDoc.h"
#include "oh_joyView.h"
#include "Zoomer.h"
#include "UnZoomer.h"
#include "Center.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COh_joyView

IMPLEMENT_DYNCREATE(COh_joyView, CScrollView)

BEGIN_MESSAGE_MAP(COh_joyView, CScrollView)
	//{{AFX_MSG_MAP(COh_joyView)
	ON_WM_SIZE()
	ON_COMMAND(ID_ACTIONS_RENDER, OnActionsRender)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONUP()
	ON_COMMAND(ID_ACTIONS_RECENTER, OnActionsRecenter)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COh_joyView construction/destruction

COh_joyView::COh_joyView()
{
	// TODO: add construction code here
	m_Rendered=true;
	m_dragging=0;
	m_ReCenter=false;
	m_HCross = AfxGetApp()->LoadStandardCursor(IDC_CROSS);
	m_HArrows = AfxGetApp()->LoadStandardCursor(IDC_SIZEALL);
}

COh_joyView::~COh_joyView()
{
}

BOOL COh_joyView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// COh_joyView drawing

void COh_joyView::OnDraw(CDC* pDC)
{
	int grid_index_a, grid_index_b;
	COh_joyDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here

    m_Delta_x=(m_Max_x-pDoc->m_Render_width)/2;
    m_Delta_y=(m_Max_y-pDoc->m_Render_height)/2;
	if (m_Delta_x<0) m_Delta_x=0;
	if (m_Delta_y<0) m_Delta_y=0;

	if (m_Rendered)
	{
		for ( loop_i=0; loop_i<pDoc->m_Render_height; loop_i++ )
		{
			grid_index_a = loop_i * pDoc->m_Render_width;
			for(loop_j=0; loop_j<pDoc->m_Render_width; loop_j++ )
			{
				grid_index_b = grid_index_a + loop_j;
				pDC->SetPixelV((int)(loop_j+m_Delta_x),(int)(loop_i+m_Delta_y),pDoc->m_Grid[grid_index_b]);
			}
		}
	}
	else
	{
		Render();
		m_Rendered=true;
	}
}

/////////////////////////////////////////////////////////////////////////////
// COh_joyView diagnostics

#ifdef _DEBUG
void COh_joyView::AssertValid() const
{
	CScrollView::AssertValid();
}

void COh_joyView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

COh_joyDoc* COh_joyView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(COh_joyDoc)));
	return (COh_joyDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COh_joyView message handlers


void COh_joyView::OnSize(UINT nType, int cx, int cy) 
{

	CScrollView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	m_Max_x = cx;
	m_Max_y = cy;

}

void COh_joyView::OnActionsRender() 
{
	// TODO: Add your command handler code here
	int new_x,new_y;

	COh_joyDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	m_Rendered=false;

	if (m_Max_x<=pDoc->m_Render_width)
		new_x = pDoc->m_Render_width;
	else
		new_x = m_Max_x;

	if (m_Max_y<=pDoc->m_Render_height)
		new_y = pDoc->m_Render_height;
	else
		new_y = m_Max_y;

	SIZE Size = {new_x,new_y};
	SetScrollSizes(MM_TEXT, Size);
	Invalidate();
}

void COh_joyView::loop_simple_render(COh_joyDoc* pDoc,CClientDC* CDC,double &x1,double &y1,int begin,int end,COLORREF color)
{
	double a,b,c,d,e,f,pre_x,pre_y,virtual_width,virtual_height,sign;
	int grid_index_a,grid_index_b,screen_x,screen_y;

	a=pDoc->m_A;
	b=pDoc->m_B;
	c=pDoc->m_C;
	d=pDoc->m_D;
	e=pDoc->m_E;
	f=pDoc->m_F;
	virtual_width=pDoc->m_Right-pDoc->m_Left;
	virtual_height=pDoc->m_Top-pDoc->m_Bottom;

	for ( loop_i=(int)begin; loop_i<(int)end; loop_i++ )
	{
		if(x1<0)
		{
			sign=-1;
		}
		else
		{
			if (x1==0)
			{
				sign=0;
			}
			else
			{
				sign=1;
			}
		}
		new_position(x1,y1,a,b,c,d,e,f,sign);
		pre_x=(x1-pDoc->m_Left)*(pDoc->m_Render_width-1)/virtual_width;
		pre_y=(pDoc->m_Render_height-1)-((y1-pDoc->m_Bottom)*(pDoc->m_Render_height-1)/virtual_height);
		screen_x=(int)(pre_x);
		screen_y=(int)(pre_y);
        if ((screen_y>=0)&&(screen_y<pDoc->m_Render_height))
			if ((screen_x>=0)&&(screen_x<pDoc->m_Render_width))
			{
				CDC->SetPixelV((screen_x+m_Delta_x),(screen_y+m_Delta_y),color);
				grid_index_a=screen_y*pDoc->m_Render_width;
				grid_index_b=grid_index_a+screen_x;
				pDoc->m_Grid[grid_index_b]=color;
			}
	}
}

void COh_joyView::loop_gradient_render(COh_joyDoc* pDoc,CClientDC* CDC,double &x1,double &y1,
		int begin,int end,COLORREF color1,COLORREF color2)
{
	double a,b,c,d,e,f,pre_x,pre_y,virtual_width,virtual_height,sign;
	double clr_1_r,clr_1_g,clr_1_b,clr_2_r,clr_2_g,clr_2_b;
	double grd_r,grd_g,grd_b,interval,scaler;
	int grid_index_a,grid_index_b,screen_x,screen_y;
	COLORREF grad_color;


	a=pDoc->m_A;
	b=pDoc->m_B;
	c=pDoc->m_C;
	d=pDoc->m_D;
	e=pDoc->m_E;
	f=pDoc->m_F;
	virtual_width=pDoc->m_Right-pDoc->m_Left;
	virtual_height=pDoc->m_Top-pDoc->m_Bottom;
	clr_1_r=(double)(GetRValue(color1));
	clr_1_g=(double)(GetGValue(color1));
	clr_1_b=(double)(GetBValue(color1));
	clr_2_r=(double)(GetRValue(color2));
	clr_2_g=(double)(GetGValue(color2));
	clr_2_b=(double)(GetBValue(color2));
	interval=(double)(end-begin);

	for ( loop_i=begin; loop_i<end; loop_i++ )
	{
		if(x1<0)
		{
			sign=-1;
		}
		else
		{
			if (x1==0)
			{
				sign=0;
			}
			else
			{
				sign=1;
			}
		}
		new_position(x1,y1,a,b,c,d,e,f,sign);
		pre_x=(x1-pDoc->m_Left)*(pDoc->m_Render_width-1)/virtual_width;
		pre_y=(pDoc->m_Render_height-1)-((y1-pDoc->m_Bottom)*(pDoc->m_Render_height-1)/virtual_height);
		screen_x=(int)(pre_x);
		screen_y=(int)(pre_y);
        if ((screen_y>=0)&&(screen_y<pDoc->m_Render_height))
			if ((screen_x>=0)&&(screen_x<pDoc->m_Render_width))
			{
				scaler=((double)(loop_i-begin))/interval;
				grd_r=(clr_1_r*(1-scaler))+(clr_2_r*scaler);
				grd_g=(clr_1_g*(1-scaler))+(clr_2_g*scaler);
				grd_b=(clr_1_b*(1-scaler))+(clr_2_b*scaler);
				grad_color=RGB((BYTE)(grd_r),(BYTE)(grd_g),(BYTE)(grd_b));
				CDC->SetPixelV((screen_x+m_Delta_x),(screen_y+m_Delta_y),grad_color);
				grid_index_a=screen_y*pDoc->m_Render_width;
				grid_index_b=grid_index_a+screen_x;
				pDoc->m_Grid[grid_index_b]=grad_color;
			}
	}
}

void COh_joyView::loop_blend_simple_render(COh_joyDoc* pDoc,CClientDC* CDC,double &x1,double &y1,int begin,int end,COLORREF color)
{
	double a,b,c,d,e,f,pre_x,pre_y,virtual_width,virtual_height,sign;
	int grid_index_a,grid_index_b,screen_x,screen_y;
	BYTE red,green,blue,loop_red,loop_green,loop_blue;
	COLORREF pixel_color;

	loop_red=GetRValue(color);  
	loop_green=GetGValue(color);  
	loop_blue=GetBValue(color);

	a=pDoc->m_A;
	b=pDoc->m_B;
	c=pDoc->m_C;
	d=pDoc->m_D;
	e=pDoc->m_E;
	f=pDoc->m_F;
	virtual_width=pDoc->m_Right-pDoc->m_Left;
	virtual_height=pDoc->m_Top-pDoc->m_Bottom;

	for ( loop_i=begin; loop_i<end; loop_i++ )
	{
		if(x1<0)
		{
			sign=-1;
		}
		else
		{
			if (x1==0)
			{
				sign=0;
			}
			else
			{
				sign=1;
			}
		}
		new_position(x1,y1,a,b,c,d,e,f,sign);
		pre_x=(x1-pDoc->m_Left)*(pDoc->m_Render_width-1)/virtual_width;
		pre_y=(pDoc->m_Render_height-1)-((y1-pDoc->m_Bottom)*(pDoc->m_Render_height-1)/virtual_height);
		screen_x=(int)(pre_x);
		screen_y=(int)(pre_y);
        if ((screen_y>=0)&&(screen_y<pDoc->m_Render_height))
			if ((screen_x>=0)&&(screen_x<pDoc->m_Render_width))
			{
				grid_index_a=screen_y*pDoc->m_Render_width;
				grid_index_b=grid_index_a+screen_x;
				pixel_color=pDoc->m_Grid[grid_index_b];
				red=GetRValue(pixel_color);  
				green=GetGValue(pixel_color);  
				blue=GetBValue(pixel_color);
				red=(red+loop_red)/2;
				green=(green+loop_green)/2;
				blue=(blue+loop_blue)/2;
				pixel_color=RGB(red,green,blue);
				CDC->SetPixelV((screen_x+m_Delta_x),(screen_y+m_Delta_y),pixel_color);
				pDoc->m_Grid[grid_index_b]=pixel_color;
			}
	}
}

void COh_joyView::loop_blend_gradient_render(COh_joyDoc* pDoc,CClientDC* CDC,double &x1,double &y1,
		int begin,int end,COLORREF color1,COLORREF color2)
{
	double a,b,c,d,e,f,pre_x,pre_y,virtual_width,virtual_height,sign;
	double clr_1_r,clr_1_g,clr_1_b,clr_2_r,clr_2_g,clr_2_b;
	double grd_r,grd_g,grd_b,interval,scaler;
	int grid_index_a,grid_index_b,screen_x,screen_y;
	BYTE red,green,blue,loop_red,loop_green,loop_blue;
	COLORREF grad_color, pixel_color;


	a=pDoc->m_A;
	b=pDoc->m_B;
	c=pDoc->m_C;
	d=pDoc->m_D;
	e=pDoc->m_E;
	f=pDoc->m_F;
	virtual_width=pDoc->m_Right-pDoc->m_Left;
	virtual_height=pDoc->m_Top-pDoc->m_Bottom;
	clr_1_r=(double)(GetRValue(color1));
	clr_1_g=(double)(GetGValue(color1));
	clr_1_b=(double)(GetBValue(color1));
	clr_2_r=(double)(GetRValue(color2));
	clr_2_g=(double)(GetGValue(color2));
	clr_2_b=(double)(GetBValue(color2));
	interval=(double)(end-begin);

	for ( loop_i=begin; loop_i<end; loop_i++ )
	{
		if(x1<0)
		{
			sign=-1;
		}
		else
		{
			if (x1==0)
			{
				sign=0;
			}
			else
			{
				sign=1;
			}
		}
		new_position(x1,y1,a,b,c,d,e,f,sign);
		pre_x=(x1-pDoc->m_Left)*(pDoc->m_Render_width-1)/virtual_width;
		pre_y=(pDoc->m_Render_height-1)-((y1-pDoc->m_Bottom)*(pDoc->m_Render_height-1)/virtual_height);
		screen_x=(int)(pre_x);
		screen_y=(int)(pre_y);
        if ((screen_y>=0)&&(screen_y<pDoc->m_Render_height))
			if ((screen_x>=0)&&(screen_x<pDoc->m_Render_width))
			{
				scaler=((double)(loop_i-begin))/interval;
				grd_r=(clr_1_r*(1-scaler))+(clr_2_r*scaler);
				grd_g=(clr_1_g*(1-scaler))+(clr_2_g*scaler);
				grd_b=(clr_1_b*(1-scaler))+(clr_2_b*scaler);
				loop_red=(BYTE)grd_r;
				loop_green=(BYTE)grd_g;
				loop_blue=(BYTE)grd_b;
				grid_index_a=screen_y*pDoc->m_Render_width;
				grid_index_b=grid_index_a+screen_x;
				pixel_color=pDoc->m_Grid[grid_index_b];
				red=GetRValue(pixel_color);  
				green=GetGValue(pixel_color);  
				blue=GetBValue(pixel_color);
				red=(red+loop_red)/2;
				green=(green+loop_green)/2;
				blue=(blue+loop_blue)/2;
				grad_color=RGB(red,green,blue);
				CDC->SetPixelV((screen_x+m_Delta_x),(screen_y+m_Delta_y),grad_color);
				pDoc->m_Grid[grid_index_b]=grad_color;
			}
	}
}

void COh_joyView::Render()
{
	int grid_index_a, grid_index_b, max_count;
	int cnt1,cnt2,cnt3;
	int render_cnt_total;
	double x1,y1;
	COLORREF clr;
	
	COh_joyDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CClientDC CDC(this);
	OnPrepareDC(&CDC);

	if (pDoc->m_Formula=="Hopalong Formula 1")
	{
		m_Formula_number=1;
	}
	if (pDoc->m_Formula=="Hopalong Formula 2")
	{
		m_Formula_number=2;
	}
	if (pDoc->m_Formula=="Fred Schimmel's Formula")
	{
		m_Formula_number=3;
	}
	if (pDoc->m_Formula=="Three Ply")
	{
		m_Formula_number=4;
	}
	if (pDoc->m_Formula=="Quadrup 2")
	{
		m_Formula_number=5;
	}
	if (pDoc->m_Formula=="Schimmel Variant One")
	{
		m_Formula_number=6;
	}
	if (pDoc->m_Formula=="GroundNet One")
	{
		m_Formula_number=7;
	}
	if (pDoc->m_Formula=="GroundNet Two")
	{
		m_Formula_number=8;
	}
	if (pDoc->m_Formula=="GroundNet Three")
	{
		m_Formula_number=9;
	}
	if (pDoc->m_Formula=="GroundNet Four")
	{
		m_Formula_number=10;
	}
	if (pDoc->m_Formula=="GroundNet Five")
	{
		m_Formula_number=11;
	}
	if (pDoc->m_Formula=="GroundNet Six")
	{
		m_Formula_number=12;
	}
	if (pDoc->m_Formula=="GroundNet Seven")
	{
		m_Formula_number=13;
	}
	if (pDoc->m_Formula=="GroundNet Eight")
	{
		m_Formula_number=14;
	}
	if (pDoc->m_Formula=="GroundNet Nine")
	{
		m_Formula_number=15;
	}
	if (pDoc->m_Formula=="GroundNet Ten")
	{
		m_Formula_number=16;
	}
	if (pDoc->m_Formula=="GroundNet Eleven")
	{
		m_Formula_number=17;
	}
	if (pDoc->m_Formula=="GroundNet Twelve")
	{
		m_Formula_number=18;
	}
    m_Delta_x=(m_Max_x-pDoc->m_Render_width)/2;
    m_Delta_y=(m_Max_y-pDoc->m_Render_height)/2;
	if (m_Delta_x<0) m_Delta_x=0;
	if (m_Delta_y<0) m_Delta_y=0;
	clr=RGB(255,255,255);
	CDC.FillSolidRect( 0, 0, m_Max_x, m_Max_y, clr );

	render_cnt_total=pDoc->m_Render_height*pDoc->m_Render_width;
	for ( loop_i=0; loop_i<render_cnt_total; loop_i++ )
	{
		pDoc->m_Grid[loop_i]=(RGB(0,0,0));
	}

	for ( loop_i=0; loop_i<pDoc->m_Render_height; loop_i++ )
	{
		grid_index_a = loop_i * pDoc->m_Render_width;
		for(loop_j=0; loop_j<pDoc->m_Render_width; loop_j++ )
		{
			grid_index_b = grid_index_a + loop_j;
			CDC.SetPixelV((int)(loop_j+m_Delta_x),(int)(loop_i+m_Delta_y),pDoc->m_Grid[grid_index_b]);
		}
	}
	max_count=pDoc->m_Iteration;
	x1=pDoc->m_Init_x;
	y1=pDoc->m_Init_y;
	if (pDoc->m_plot_mode=="Overwrite (Simple)")
	{
		cnt1=max_count/4;
		cnt2=max_count/2;
		cnt3=(max_count*3)/4;
		loop_simple_render(pDoc,&CDC,x1,y1,0,cnt1,pDoc->m_color_1);
		loop_simple_render(pDoc,&CDC,x1,y1,cnt1,cnt2,pDoc->m_color_2);
		loop_simple_render(pDoc,&CDC,x1,y1,cnt2,cnt3,pDoc->m_color_3);
		loop_simple_render(pDoc,&CDC,x1,y1,cnt3,max_count,pDoc->m_color_4);
	}
	if (pDoc->m_plot_mode=="Overwrite (Gradient)")
	{
		cnt1=max_count/3;
		cnt2=(max_count*2)/4;
		loop_gradient_render(pDoc,&CDC,x1,y1,0,cnt1,pDoc->m_color_1,pDoc->m_color_2);
		loop_gradient_render(pDoc,&CDC,x1,y1,cnt1,cnt2,pDoc->m_color_2,pDoc->m_color_3);
		loop_gradient_render(pDoc,&CDC,x1,y1,cnt2,max_count,pDoc->m_color_3,pDoc->m_color_4);
	}
	if (pDoc->m_plot_mode=="Blend (Simple)")
	{
		cnt1=max_count/4;
		cnt2=max_count/2;
		cnt3=(max_count*3)/4;
		loop_blend_simple_render(pDoc,&CDC,x1,y1,0,cnt1,pDoc->m_color_1);
		loop_blend_simple_render(pDoc,&CDC,x1,y1,cnt1,cnt2,pDoc->m_color_2);
		loop_blend_simple_render(pDoc,&CDC,x1,y1,cnt2,cnt3,pDoc->m_color_3);
		loop_blend_simple_render(pDoc,&CDC,x1,y1,cnt3,max_count,pDoc->m_color_4);
	}
	if (pDoc->m_plot_mode=="Blend (Gradient)")
	{
		cnt1=max_count/3;
		cnt2=(max_count*2)/4;
		loop_blend_gradient_render(pDoc,&CDC,x1,y1,0,cnt1,pDoc->m_color_1,pDoc->m_color_2);
		loop_blend_gradient_render(pDoc,&CDC,x1,y1,cnt1,cnt2,pDoc->m_color_2,pDoc->m_color_3);
		loop_blend_gradient_render(pDoc,&CDC,x1,y1,cnt2,max_count,pDoc->m_color_3,pDoc->m_color_4);
	}
}

void COh_joyView::OnInitialUpdate() 
{
	CScrollView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	SIZE Size = {m_Max_x,m_Max_y};
	SetScrollSizes(MM_TEXT, Size);	
}

void COh_joyView::new_position(double &x1, double &y1, double a, double b, double c, double d, double e, double f, double sign)
{
	double temp,x2,y2;

	if (m_Formula_number==1)
	{
		x2=y1-(sign*sqrt(fabs((b*x1)-c)));
		y2=a-x1;
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	if (m_Formula_number==2)
	{
		x2=y1-(b*sin(x1));
		y2=a-(c*x1);
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	if (m_Formula_number==3)
	{
		x2=(x1-a)*sin(d)-(y1-(sign*pow(fabs(b*x1-c),fabs(e))))*cos(d);
		y2=(x1-a)*cos(d)+(y1-(sign*pow(fabs(b*x1-c),fabs(e))))*sin(d);
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	if (m_Formula_number==4)
	{
		x2=y1-sign*( (sin(x1)*a) + b - (x1*c) );
		y2=d-x1;
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	if (m_Formula_number==5)
	{
		x2=y1-sign*sin(log(fabs((b*x1)-c)+.00001))*atan(fabs((c*x1)-b)*fabs((c*x1)-b));
		y2=a-x1;
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	if (m_Formula_number==6)
	{
		x2=(x1-a)*cos(d)-(y1-(sign*pow(fabs(b*x1-c),fabs(e))))*sin(d);
		y2=(x1-a)*sin(d)+(y1-(sign*pow(fabs(b*x1-c),fabs(e))))*cos(d);
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	if (m_Formula_number==7)
	{
		x2=y1-d*sign*cos(log(fabs((b*x1)-c)+.00001))*asin(fabs((c*x1)-b)*fabs((c*x1)-b));
		y2=a-x1;
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	if (m_Formula_number==8)
	{
		x2=y1-d*sign*sin(log(fabs((b*x1)-c)+.00001))*asin(fabs((c*x1)-b)*fabs((c*x1)-b));
		y2=a-x1;
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	if (m_Formula_number==9)
	{
		x2=exp(-1*(fabs((b*x1)-c)+.00001));
		x2=y1-d*sign*sin(x2)*atan(x2*x2);
		y2=a-x1;
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	if (m_Formula_number==10)
	{
		x2=exp(-1*(fabs((b*x1)-c)+.00001));
		x2=y1-d*sign*atan(x2*x2);
		y2=a-x1;
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	if (m_Formula_number==11)
	{
		x2=exp(-1*(fabs((b*x1)-c)+.00001));
		x2=y1-d*sign*asin(x2);
		y2=a-x1;
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	if (m_Formula_number==12)
	{
		x2=exp(-1*(fabs((b*x1)-c)+.00001));
		x2=y1-d*sign*acos(x2);
		y2=a-x1;
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	if (m_Formula_number==13)
	{
		x2=exp(-1*(fabs((b*x1)-c)+.00001));
		x2=y1-d*sign*acos(x2)*x2;
		y2=a-x1;
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	if (m_Formula_number==14)
	{
		x2=exp(-1*(fabs((b*x1)-c)+.00001));
		x2=y1-d*sign*atan(x2);
		y2=a-x1;
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	if (m_Formula_number==15)
	{
		x2=exp(-1*(fabs((b*x1)-c)+.00001));
		x2=y1-d*sign*cos(x2)*atan(x2*x2);
		y2=a-x1;
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	if (m_Formula_number==16)
	{
		x2=exp(-1*(fabs((b*x1)-c)+.00001));
		x2=y1-d*sign*asin(x2)*x2;
		y2=a-x1;
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	if (m_Formula_number==17)
	{
		x2=exp(-1*(fabs((b*x1)-c)+.00001));
		x2=y1-d*sign*atan(x2)*x2;
		y2=a-x1;
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	if (m_Formula_number==18)
	{
		x2=y1-sign*( (cos(x1)*a) + b - (x1*c) );
		y2=d-x1;
		temp=f*3.14159265/180;
		x1=x2;
		y1=y2;
		x2=(x1*cos(temp))-(y1*sin(temp));
		y2=(x1*sin(temp))+(y1*cos(temp));
	}
	x1=x2;
	y1=y2;
}


void COh_joyView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	CClientDC CDC(this);
	OnPrepareDC(&CDC);
	CDC.DPtoLP(&point);

	m_Begin = point;
	m_End = point;
	if (!m_ReCenter)
	{
		SetCapture();
		m_dragging = 1;
		RECT Rect;
		GetClientRect(&Rect);
		ClientToScreen(&Rect);
		::ClipCursor(&Rect);
	}
	
	CScrollView::OnLButtonDown(nFlags, point);
}

void COh_joyView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	int temp_xb,temp_xe,temp_yb,temp_ye;
	double pd_L,pd_B,pd_RW,pd_RH,VW,VH,DX,DY;
	double center_x,center_y;
	Zoomer ZoomDLG;
	Center CenterDLG;

	COh_joyDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pd_L=pDoc->m_Left;
	pd_B=pDoc->m_Bottom;
	pd_RW=pDoc->m_Render_width-1;
	pd_RH=pDoc->m_Render_height-1;
	VW=pDoc->m_Right-pDoc->m_Left;
	VH=pDoc->m_Top-pDoc->m_Bottom;
	DX=m_Delta_x;
	DY=m_Delta_y;

	if (m_ReCenter)
	{
		::ReleaseCapture();
		::ClipCursor(NULL);
		CClientDC CDC(this);
		OnPrepareDC(&CDC);
		CDC.DPtoLP(&point);
		center_x=((point.x-DX)*VW/pd_RW)+pd_L;
		center_y=((1-((point.y-DY)/pd_RH))*VH)+pd_B;
		CenterDLG.m_Top=center_y+(.5*VH);
		CenterDLG.m_Bottom=center_y-(.5*VH);
		CenterDLG.m_Left=center_x-(.5*VW);
		CenterDLG.m_Right=center_x+(.5*VW);
		if (CenterDLG.DoModal()==IDOK)
		{
			pDoc->m_Bottom=CenterDLG.m_Bottom;
			pDoc->m_Left=CenterDLG.m_Left;
			pDoc->m_Right=CenterDLG.m_Right;
			pDoc->m_Top=CenterDLG.m_Top;
			m_Rendered=false;
			Invalidate();
		}
		m_ReCenter=false;
		m_dragging=0;
	}

	if (m_dragging)
	{
		m_dragging=0;
		::ReleaseCapture();
		::ClipCursor(NULL);
		CClientDC CDC(this);
		OnPrepareDC(&CDC);
		CDC.DPtoLP(&point);

		CDC.SetROP2(R2_NOT);
		CDC.SelectStockObject(NULL_BRUSH);
		CDC.Rectangle(m_Begin.x,m_Begin.y,m_End.x,m_End.y);
		if ((fabs(m_Begin.x-m_End.x)>2)&&(fabs(m_Begin.y-m_End.y)>2))
		{
			if (m_Begin.x<m_End.x)
			{
				temp_xb=m_Begin.x+1;
				temp_xe=m_End.x-1;
			}
			else
			{
				temp_xb=m_Begin.x-1;
				temp_xe=m_End.x+1;
			}
			if (m_Begin.y<m_End.y)
			{
				temp_yb=m_Begin.y+1;
				temp_ye=m_End.y-1;
			}
			else
			{
				temp_yb=m_Begin.y-1;
				temp_ye=m_End.y+1;
			}
			CDC.Rectangle(temp_xb,temp_yb,temp_xe,temp_ye);
		}
		if ((fabs(m_Begin.x-m_End.x)>1)&&(fabs(m_Begin.y-m_End.y)>1))
		{
			CDC.SetROP2(R2_COPYPEN);

			if (m_Begin.x<=m_End.x)
			{
				ZoomDLG.m_Left=((m_Begin.x-DX)*VW/pd_RW)+pd_L;
				ZoomDLG.m_Right=((m_End.x-DX)*VW/pd_RW)+pd_L;
			}
			else
			{
				ZoomDLG.m_Left=((m_End.x-DX)*VW/pd_RW)+pd_L;
				ZoomDLG.m_Right=((m_Begin.x-DX)*VW/pd_RW)+pd_L;
			}
			if (m_Begin.y<=m_End.y)
			{
				ZoomDLG.m_Top=((1-((m_Begin.y-DY)/pd_RH))*VH)+pd_B;
				ZoomDLG.m_Bottom=((1-((m_End.y-DY)/pd_RH))*VH)+pd_B;
			}
			else
			{
				ZoomDLG.m_Top=((1-((m_End.y-DY)/pd_RH))*VH)+pd_B;
				ZoomDLG.m_Bottom=((1-((m_Begin.y-DY)/pd_RH))*VH)+pd_B;
			}

			if (ZoomDLG.DoModal()==IDOK)
			{
				pDoc->m_Bottom=ZoomDLG.m_Bottom;
				pDoc->m_Left=ZoomDLG.m_Left;
				pDoc->m_Right=ZoomDLG.m_Right;
				pDoc->m_Top=ZoomDLG.m_Top;
				m_Rendered=false;
				Invalidate();
			}
		}
	}
	
	CScrollView::OnLButtonUp(nFlags, point);
}



void COh_joyView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	int temp_xb,temp_xe,temp_yb,temp_ye;

	if (m_ReCenter)	::SetCursor(m_HArrows);

	if ((m_dragging)&&(!m_ReCenter))
	{
		::SetCursor(m_HCross);
		CClientDC CDC(this);
		OnPrepareDC(&CDC);
		CDC.DPtoLP(&point);

		CDC.SetROP2(R2_NOT);
		CDC.SelectStockObject(NULL_BRUSH);
		CDC.Rectangle(m_Begin.x,m_Begin.y,m_End.x,m_End.y);
		if ((fabs(m_Begin.x-m_End.x)>2)&&(fabs(m_Begin.y-m_End.y)>2))
		{
			if (m_Begin.x<m_End.x)
			{
				temp_xb=m_Begin.x+1;
				temp_xe=m_End.x-1;
			}
			else
			{
				temp_xb=m_Begin.x-1;
				temp_xe=m_End.x+1;
			}
			if (m_Begin.y<m_End.y)
			{
				temp_yb=m_Begin.y+1;
				temp_ye=m_End.y-1;
			}
			else
			{
				temp_yb=m_Begin.y-1;
				temp_ye=m_End.y+1;
			}
			CDC.Rectangle(temp_xb,temp_yb,temp_xe,temp_ye);
		}
		m_End=point;
		CDC.Rectangle(m_Begin.x,m_Begin.y,m_End.x,m_End.y);
		if ((fabs(m_Begin.x-m_End.x)>2)&&(fabs(m_Begin.y-m_End.y)>2))
		{
			if (m_Begin.x<m_End.x)
			{
				temp_xb=m_Begin.x+1;
				temp_xe=m_End.x-1;
			}
			else
			{
				temp_xb=m_Begin.x-1;
				temp_xe=m_End.x+1;
			}
			if (m_Begin.y<m_End.y)
			{
				temp_yb=m_Begin.y+1;
				temp_ye=m_End.y-1;
			}
			else
			{
				temp_yb=m_Begin.y-1;
				temp_ye=m_End.y+1;
			}
			CDC.Rectangle(temp_xb,temp_yb,temp_xe,temp_ye);
		}
	}
	
	CScrollView::OnMouseMove(nFlags, point);
}

void COh_joyView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	double pd_T,pd_L,pd_B,pd_R,DW,DH;
	UnZoomer UnZoomDLG;

	COh_joyDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pd_T=pDoc->m_Top;
	pd_L=pDoc->m_Left;
	pd_B=pDoc->m_Bottom;
	pd_R=pDoc->m_Right;

	DH=(pd_T-pd_B)/2;
	DW=(pd_R-pd_L)/2;

	pd_T += DH;
	pd_B -= DH;
	pd_R += DW;
	pd_L -= DW;

	UnZoomDLG.m_Top=pd_T;
	UnZoomDLG.m_Bottom=pd_B;
	UnZoomDLG.m_Right=pd_R;
	UnZoomDLG.m_Left=pd_L;

	if (UnZoomDLG.DoModal()==IDOK)
	{
		pDoc->m_Bottom=UnZoomDLG.m_Bottom;
		pDoc->m_Left=UnZoomDLG.m_Left;
		pDoc->m_Right=UnZoomDLG.m_Right;
		pDoc->m_Top=UnZoomDLG.m_Top;
		m_Rendered=false;
		Invalidate();
	}

	
	CScrollView::OnRButtonUp(nFlags, point);
}

void COh_joyView::OnActionsRecenter() 
{
	// TODO: Add your command handler code here
	m_ReCenter=true;	
}

